'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ArrowKeyNavigator = exports.isArrowKey = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inc = function inc(n) {
    return n + 1;
};
var dec = function dec(n) {
    return n - 1;
};
var decX = function decX(_ref) {
    var _ref2 = _slicedToArray(_ref, 2);

    var y = _ref2[0];
    var x = _ref2[1];
    return [y, dec(x)];
};
var decY = function decY(_ref3) {
    var _ref4 = _slicedToArray(_ref3, 2);

    var y = _ref4[0];
    var x = _ref4[1];
    return [dec(y), x];
};
var incX = function incX(_ref5) {
    var _ref6 = _slicedToArray(_ref5, 2);

    var y = _ref6[0];
    var x = _ref6[1];
    return [y, inc(x)];
};
var incY = function incY(_ref7) {
    var _ref8 = _slicedToArray(_ref7, 2);

    var y = _ref8[0];
    var x = _ref8[1];
    return [inc(y), x];
};

var ARROW_KEYS = {
    '37': decX,
    '38': decY,
    '39': incX,
    '40': incY,
    '9': incX
};

var isArrowKey = exports.isArrowKey = function isArrowKey(key) {
    return ARROW_KEYS[key];
};

var ArrowKeyNavigator = exports.ArrowKeyNavigator = _react2.default.createClass({
    displayName: 'ArrowKeyNavigator',


    propTypes: {
        className: _react.PropTypes.string,
        children: _react.PropTypes.node,
        onMoveSelection: _react.PropTypes.func,
        selection: _react.PropTypes.array
    },

    onKeyDown: function onKeyDown(e) {
        //const [ row, column ] = this.props.selection;
        var keyCode = e.keyCode;


        if (ARROW_KEYS[keyCode]) {
            e.preventDefault();
            this.props.onMoveSelection(ARROW_KEYS[keyCode](this.props.selection));
        }
    },
    render: function render() {
        var _props = this.props;
        var className = _props.className;
        var children = _props.children;

        return _react2.default.createElement(
            'div',
            { tabIndex: 0, onKeyDown: this.onKeyDown, className: className },
            children
        );
    }
});