'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Cell = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styles = require('./styles.css');

var _styles2 = _interopRequireDefault(_styles);

var _Editor = require('./Editor');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Cell = exports.Cell = _react2.default.createClass({
    displayName: 'Cell',


    contextTypes: {
        onEditCompleted: _react.PropTypes.func
    },

    render: function render() {
        var props = this.props;
        var index = props.index;
        var colIndex = props.colIndex;
        var record = props.record;
        var colConfig = props.colConfig;
        var selection = props.selection;
        var edited = props.edited;

        var selected = selection[0] === index && selection[1] === colIndex;
        var bottomSelected = selection[0] === index + 1 && selection[1] === colIndex;
        var prevSelected = selection[0] === index && selection[1] === colIndex - 1;
        var classNames = (0, _classnames2.default)(_styles2.default['cell-cont'], _styles2.default['cell'], _defineProperty({}, _styles2.default['cell-selected'], selected), _defineProperty({}, _styles2.default['cell-normal'], !selected), _defineProperty({}, _styles2.default['cell-bottom-selected'], bottomSelected), _defineProperty({}, _styles2.default['cell-prev-selected'], prevSelected), _styles2.default[props.className]);

        var renderer = colConfig.renderer;
        var formatter = colConfig.formatter;

        var originalValue = record[colConfig.id];
        var value = formatter ? formatter({ value: originalValue, record: record }) : originalValue;

        var containerProps = { 'data-col-index': colIndex, className: classNames, 'data-index': props.index, 'data-id': colConfig.id };
        if (edited && edited.index === index && edited.id === colConfig.id) {

            return _react2.default.createElement(
                'div',
                _extends({}, containerProps, { style: { background: '#FFF' } }),
                _react2.default.createElement(_Editor.Editor, _extends({ onEditCompleted: this.context.onEditCompleted, value: edited.input }, { index: index, record: record, colConfig: colConfig }))
            );
        } else {
            if (renderer) {
                return renderer(_extends({}, containerProps, { value: value, originalValue: originalValue, record: record }));
            } else {
                var x = selected ? { border: '1px solid #7ec0ee' } : { border: '1px solid transparent' };
                return _react2.default.createElement(
                    'div',
                    containerProps,
                    _react2.default.createElement(
                        'div',
                        { className: _styles2.default['cell-cont-inner'], style: _extends({}, x) },
                        value
                    )
                );
            }
        }
    }
});

Cell.propTypes = {
    index: _react.PropTypes.number.isRequired,
    record: _react.PropTypes.object.isRequired,
    colConfig: _react.PropTypes.object.isRequired,
    onClick: _react.PropTypes.func,
    className: _react.PropTypes.string
};