'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Row = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Cell = require('./Cell');

var _styles = require('./styles.css');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Row = exports.Row = _react2.default.createClass({
    displayName: 'Row',

    propTypes: {
        index: _react.PropTypes.number.isRequired,
        dataProvider: _react.PropTypes.object.isRequired,
        colConfigs: _react.PropTypes.array.isRequired,
        onClick: _react.PropTypes.func,
        edited: _react.PropTypes.object,
        selection: _react.PropTypes.array
    },

    onClick: function onClick() {
        if (this.props.onClick) {
            this.props.onClick(this.props.index);
        }
    },
    renderCells: function renderCells() {
        var _props = this.props;
        var dataProvider = _props.dataProvider;
        var selection = _props.selection;
        var index = _props.index;
        var colConfigs = _props.colConfigs;
        var edited = _props.edited;

        var record = dataProvider.recordAt(index);

        return colConfigs.map(function (colConfig, cidx) {
            var className = cidx === colConfigs.length - 1 ? 'cell-last' : '';
            return _react2.default.createElement(_Cell.Cell, _extends({ key: colConfig.id + '-' + index + '-' + cidx, className: className
            }, { selection: selection, record: record, colIndex: cidx, index: index, colConfig: colConfig, edited: edited }));
        });
    },
    render: function render() {

        return _react2.default.createElement(
            'div',
            { onClick: this.onClick, className: _styles2.default['row'] },
            this.renderCells()
        );
    }
});