'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TotalsContainer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RowContainer = require('./RowContainer');

var _arrayDataProvider = require('./arrayDataProvider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var sumField = function sumField(field) {
    return function (f1, f2) {
        return _defineProperty({}, field, f1[field] + f2[field]);
    };
};

var sumFields = function sumFields(fields) {
    return function (f1, f2) {
        var obj = {};
        fields.map(sumField).forEach(function (fieldSummer) {
            obj = _extends({}, obj, fieldSummer(f1, f2));
        });
        return obj;
    };
};

var TotalsContainer = exports.TotalsContainer = function TotalsContainer(props) {
    var fieldsToTotal = props.colConfigs.filter(function (cfg) {
        return cfg.totals;
    }).map(function (cfg) {
        return cfg.id;
    });
    var totals = props.dataProvider.reduce(sumFields(fieldsToTotal));
    if (totals && totals.length > 0) {
        return _react2.default.createElement(_RowContainer.RowContainer, { selection: props.selection, dataProvider: (0, _arrayDataProvider.create)([totals]), colConfigs: props.colConfigs });
    }
    return null;
};

TotalsContainer.propTypes = {
    colConfigs: _react.PropTypes.array,
    dataProvider: _react.PropTypes.object
};