'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ComboBox = undefined;
exports.getOffSet = getOffSet;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OptionList = _react2.default.createClass({
    displayName: 'OptionList',


    propTypes: {
        options: _react.PropTypes.array,
        top: _react.PropTypes.number,
        left: _react.PropTypes.number
    },

    render: function render() {
        return _react2.default.createElement(
            'div',
            { style: { width: 182, top: this.props.top, left: this.props.left },
                className: _style2.default['combobox-options-cont'] },
            this.props.options.map(function (option) {
                return _react2.default.createElement(
                    'div',
                    { style: { padding: 8 }, key: option },
                    _react2.default.createElement(
                        'span',
                        null,
                        option
                    )
                );
            })
        );
    }
});

function getOffSet(el) {
    var rect = el.getBoundingClientRect();
    return {
        left: rect.left + window.scrollX,
        top: rect.top + window.scrollY
    };
};

var OptionListContainer = _react2.default.createClass({
    displayName: 'OptionListContainer',

    propTypes: {
        options: _react.PropTypes.array,
        anchorEl: _react.PropTypes.object.isRequired,
        containerEl: _react.PropTypes.object.isRequired
    },

    componentDidMount: function componentDidMount() {
        var mountPoint = document.createElement('div');
        document.body.appendChild(mountPoint);
        this._mountPoint = mountPoint;

        this.renderOptionList(this.props);
    },
    renderOptionList: function renderOptionList(props) {
        var _getOffSet = getOffSet(props.anchorEl);

        var top = _getOffSet.top;
        var left = _getOffSet.left;

        var offset = props.containerEl.clientHeight;

        (0, _reactDom.render)(_react2.default.createElement(OptionList, { top: top + offset, left: left,
            options: props.options }), this._mountPoint);
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        this.renderOptionList(nextProps);
    },
    componentWillUnmount: function componentWillUnmount() {
        (0, _reactDom.unmountComponentAtNode)(this._mountPoint);
        document.body.deleteChild(this._mountPoint);
        delete this._mountPoint;
    },
    render: function render() {
        return _react2.default.createElement('noscript', null);
    }
});

var ComboBox = _react2.default.createClass({
    displayName: 'ComboBox',


    propTypes: {
        name: _react.PropTypes.string.isRequired,
        options: _react.PropTypes.array.isRequired
    },

    getInitialState: function getInitialState() {
        return { inputWidth: 5 };
    },
    onContainerClick: function onContainerClick() {
        //const inputNode = this.refs.input;
        //inputNode.focus();
        this.__input.focus();
    },
    onInputFocus: function onInputFocus() {},
    onInputChange: function onInputChange() {
        var inputNode = this.__input; //this.refs.input;
        var inputWidth = this.state.inputWidth;


        this.setState({ inputWidth: inputWidth + 8, inputValue: inputNode.value });
    },

    containerRef: function containerRef(el) {
        this.__container = el;
    },
    inputRef: function inputRef(el) {
        this.__input = el;
    },

    filterOptions: function filterOptions() {
        var options = this.props.options;
        var inputValue = this.state.inputValue;

        if (inputValue) {
            return options.filter(function (option) {
                return option.indexOf(inputValue) > -1;
            });
        }
        return options;
    },
    render: function render() {
        var _state = this.state;
        var inputValue = _state.inputValue;
        var inputWidth = _state.inputWidth;


        return _react2.default.createElement(
            'div',
            { ref: this.containerRef, onClick: this.onContainerClick, style: { width: 184 }, className: _style2.default['input'] },
            _react2.default.createElement('input', { onFocus: this.onInputFocus, value: inputValue, onChange: this.onInputChange,
                ref: this.inputRef, className: _style2.default['input-combobox'],
                style: { width: inputWidth } }),
            inputValue ? _react2.default.createElement(OptionListContainer, {
                containerEl: this.__container,
                anchorEl: this.__container, options: this.filterOptions() }) : null
        );
    }
});

exports.ComboBox = ComboBox;
exports.default = ComboBox;