'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Inline = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_CONT_STYLE = { width: '100%', display: 'inline-flex', flexDirection: 'row', verticalAlign: 'middle' };
var assign = Object.assign;

var DEFAULT_BASIS = '100%';

var Inline = function Inline(props) {

    var showLabel = props.showLabel === false ? false : true;
    var contStyle = assign({}, DEFAULT_CONT_STYLE, props.width ? { width: props.width } : {});
    return _react2.default.createElement(
        'div',
        { style: contStyle },
        showLabel ? _react2.default.createElement(
            'div',
            { className: _style2.default['inline-label'],
                style: assign({ display: 'flex', justifyContent: 'flex-end' }, props.labelStyle) },
            props.children.props.label || (0, _utils.createLabel)(props.children.props.name)
        ) : null,
        _react.Children.map(props.children, function (child) {
            var basis = child.props.width || DEFAULT_BASIS;
            return _react2.default.createElement(
                'div',
                { style: { paddingRight: 10, display: 'inline-flex', flex: '0 1 ' + basis } },
                child
            );
        })
    );
};

Inline.propTypes = {
    labelStyle: _react.PropTypes.object,
    showLabel: _react.PropTypes.bool,
    width: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    children: _react.PropTypes.node
};

exports.Inline = Inline;
exports.default = Inline;