'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Input = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _fkitJs = require('fkit-js');

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_Component) {
    _inherits(Input, _Component);

    function Input() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Input);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Input, [{
        key: 'render',
        value: function render() {
            var props = this.props;


            var inputStyle = _extends({}, props.width ? { width: props.width } : { width: '100%' }, props.style);
            return _react2.default.createElement('input', _extends({}, this.props, { ref: 'input', style: inputStyle, value: (0, _utils.getValue)(this.props, this.context),
                className: _style2.default['input'], onChange: this.handleChange }));
        }
    }]);

    return Input;
}(_react.Component);

Input.contextTypes = {
    model: _react.PropTypes.object,
    onChange: _react.PropTypes.func
};
Input.propTypes = {
    name: _react.PropTypes.string,
    onChange: _react.PropTypes.func,
    value: _react.PropTypes.string,
    width: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    type: _react.PropTypes.string,
    path: _react.PropTypes.string
};

var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.handleChange = function (e) {
        var listenerContext = _this2.context.onChange || _fkitJs.Id;
        var listenerProps = _this2.props.onChange || _fkitJs.Id;

        var args = [_this2.props.name, e.target.value, _this2.props.path, e.target];
        listenerContext.apply(undefined, args);
        listenerProps.apply(undefined, args);
    };

    this.inputValue = function () {
        return _this2.refs.input.value;
    };

    this.clear = function () {
        _this2.refs.input.value = '';
    };
};

exports.Input = Input;
exports.default = Input;