'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Select = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('./utils');

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _fkitJs = require('fkit-js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var optionMapper = function optionMapper(props) {
    var _props$valueKey = props.valueKey;
    var valueKey = _props$valueKey === undefined ? 'value' : _props$valueKey;
    var _props$textKey = props.textKey;
    var textKey = _props$textKey === undefined ? 'text' : _props$textKey;

    (function (option) {
        var value = null;
        var text = null;

        if (typeof option === 'string' || typeof option === 'number') {
            value = option;
            text = option;
        } else {
            value = option[valueKey];
            text = option[textKey];
        }
        return _react2.default.createElement(
            'option',
            { value: value },
            text
        );
    });
};

var Select = _react2.default.createClass({
    displayName: 'Select',

    contextTypes: {
        model: _react.PropTypes.object,
        onChange: _react.PropTypes.func
    },

    propTypes: {
        name: _react.PropTypes.string,
        optional: _react.PropTypes.bool, //if we should add an empty selection
        optionalText: _react.PropTypes.string, //the text on the optional selection
        options: _react.PropTypes.array,
        onChange: _react.PropTypes.func,
        valueKey: _react.PropTypes.string,
        textKey: _react.PropTypes.string,
        path: _react.PropTypes.string

    },
    createOptions: function createOptions() {
        var _props = this.props;
        var _props$optional = _props.optional;
        var optional = _props$optional === undefined ? true : _props$optional;
        var _props$optionalText = _props.optionalText;
        var optionalText = _props$optionalText === undefined ? '' : _props$optionalText;
        var options = _props.options;


        var optionsEls = options.map(optionMapper(this.props));
        if (optional) {
            optionsEls.unshift(_react2.default.createElement(
                'option',
                { key: '__EMPTY__', value: '' },
                optionalText
            ));
        }
        return optionsEls;
    },

    handleChange: function handleChange(e) {
        var listenerContext = this.context.onChange || _fkitJs.Id;
        var listenerProps = this.props.onChange || _fkitJs.Id;

        var args = [this.props.name, e.target.value, this.props.path, e.target];
        listenerContext.apply(undefined, args);
        listenerProps.apply(undefined, args);
    },
    render: function render() {
        var props = this.props;

        var inputStyle = _extends({}, props.width ? { width: props.width } : {}, props.style);

        return _react2.default.createElement(
            'select',
            { style: inputStyle, onChange: this.handleChange, value: (0, _utils.getValue)(this.props, this.context), className: _style2.default['input'] },
            this.createOptions()
        );
    }
});

exports.Select = Select;
exports.default = Select;