'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getValue = exports.createLabel = undefined;

var _fkitJs = require('fkit-js');

var upperCaseFirstLetter = function upperCaseFirstLetter(text) {
    if (text) {
        return text.charAt(0).toUpperCase() + text.slice(1);
    }
};

var createLabel = exports.createLabel = function createLabel(labelText) {

    if (labelText) {
        return upperCaseFirstLetter(labelText.split('').map(function (ch) {
            if (ch === ch.toUpperCase()) {
                return ' ' + ch;
            } else {
                return ch;
            }
        }).reduce(function (prev, current) {
            return prev + current;
        }, ''));
    }
    return '';
};

/**
 * Retrieve the value from props or from context
 */
var getValue = exports.getValue = function getValue(props, context) {
    var path = props.path;
    var name = props.name;
    //const value = path ? traverse() : props.value;

    return props.value || function () {
        if (context.model) {
            return path ? (0, _fkitJs.get)(path)(context.model) : context.model[name];
        }
    }();
};